(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/forms'), require('@angular/common'), require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('angular-tree-grid', ['exports', '@angular/forms', '@angular/common', '@angular/core'], factory) :
    (factory((global['angular-tree-grid'] = {}),global.ng.forms,global.ng.common,global.ng.core));
}(this, (function (exports,forms,common,i0) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AngularTreeGridService = /** @class */ (function () {
        function AngularTreeGridService() {
        }
        /**
         * @param {?} data
         * @param {?} configs
         * @return {?}
         */
        AngularTreeGridService.prototype.findTopParentNode = /**
         * @param {?} data
         * @param {?} configs
         * @return {?}
         */
            function (data, configs) {
                /** @type {?} */
                var ids = data.map(( /**
                 * @param {?} element
                 * @return {?}
                 */function (element) { return element[configs.id_field]; }));
                /** @type {?} */
                var top_parents = [];
                // Find parents ie if parent_id is not present in ids.
                data.forEach(( /**
                 * @param {?} element
                 * @return {?}
                 */function (element) {
                    if (!ids.includes(element[configs.parent_id_field])) {
                        top_parents.push(element[configs.parent_id_field]);
                    }
                }));
                // Remove duplicates
                top_parents = top_parents.filter(( /**
                 * @param {?} item
                 * @param {?} pos
                 * @param {?} self
                 * @return {?}
                 */function (item, pos, self) {
                    return self.indexOf(item) === pos;
                }));
                return top_parents;
            };
        /**
         * @param {?} data
         * @param {?} processed_data
         * @param {?} expand_tracker
         * @param {?} configs
         * @param {?} edit_tracker
         * @param {?} internal_configs
         * @return {?}
         */
        AngularTreeGridService.prototype.processData = /**
         * @param {?} data
         * @param {?} processed_data
         * @param {?} expand_tracker
         * @param {?} configs
         * @param {?} edit_tracker
         * @param {?} internal_configs
         * @return {?}
         */
            function (data, processed_data, expand_tracker, configs, edit_tracker, internal_configs) {
                var _this = this;
                /** @type {?} */
                var top_parents = this.findTopParentNode(data, configs);
                internal_configs.top_parents = top_parents;
                data.map(( /**
                 * @param {?} rec
                 * @return {?}
                 */function (rec) {
                    rec.pathx = [];
                    rec.leaf = false;
                }));
                top_parents.forEach(( /**
                 * @param {?} top_parent
                 * @return {?}
                 */function (top_parent) {
                    /** @type {?} */
                    var children = _this.findChildren(data, top_parent, configs);
                    _this.orderData(data, processed_data, configs, children, [], 0);
                }));
                processed_data.map(( /**
                 * @param {?} rec
                 * @return {?}
                 */function (rec) {
                    /** @type {?} */
                    var parent_pathx = rec.parent_pathx;
                    rec.parent_pathx = parent_pathx.join('.');
                    parent_pathx.push(rec[configs.id_field]);
                    // Add current id to create current path.
                    rec.pathx = parent_pathx.join('.');
                    expand_tracker[rec.pathx] = false;
                    edit_tracker[rec[configs.id_field]] = false;
                }));
                // Expand root.
                expand_tracker[''] = true;
            };
        /**
         * @param {?} data
         * @param {?} id
         * @param {?} configs
         * @return {?}
         */
        AngularTreeGridService.prototype.findChildren = /**
         * @param {?} data
         * @param {?} id
         * @param {?} configs
         * @return {?}
         */
            function (data, id, configs) {
                return data.filter(( /**
                 * @param {?} rec
                 * @return {?}
                 */function (rec) { return rec[configs.parent_id_field] === id; }));
            };
        /**
         * @param {?} data
         * @param {?} processed_data
         * @param {?} configs
         * @param {?} parents
         * @param {?} paths
         * @param {?} levelx
         * @return {?}
         */
        AngularTreeGridService.prototype.orderData = /**
         * @param {?} data
         * @param {?} processed_data
         * @param {?} configs
         * @param {?} parents
         * @param {?} paths
         * @param {?} levelx
         * @return {?}
         */
            function (data, processed_data, configs, parents, paths, levelx) {
                var _this = this;
                parents.forEach(( /**
                 * @param {?} parent
                 * @return {?}
                 */function (parent) {
                    /** @type {?} */
                    var children = _this.findChildren(data, parent[configs.id_field], configs);
                    if (children.length === 0) {
                        parent.leaf = true;
                        parent.levelx = levelx;
                        parent.parent_pathx = __spread(paths);
                        processed_data.push(parent);
                    }
                    else {
                        parent.parent_pathx = __spread(paths);
                        parent.levelx = levelx;
                        processed_data.push(parent);
                        /** @type {?} */
                        var newPaths = __spread(paths, [parent[configs.id_field]]);
                        _this.orderData(data, processed_data, configs, children, newPaths, levelx + 1);
                    }
                }));
            };
        AngularTreeGridService.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        AngularTreeGridService.ctorParameters = function () { return []; };
        /** @nocollapse */ AngularTreeGridService.ngInjectableDef = i0.defineInjectable({ factory: function AngularTreeGridService_Factory() { return new AngularTreeGridService(); }, token: AngularTreeGridService, providedIn: "root" });
        return AngularTreeGridService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AngularTreeGridComponent = /** @class */ (function () {
        function AngularTreeGridComponent(angularTreeGridService) {
            this.angularTreeGridService = angularTreeGridService;
            this.processed_data = [];
            this.expand_tracker = {};
            this.columns = [];
            this.edit_tracker = {}; // Track Edit options.
            // Track Edit options.
            this.internal_configs = {
                show_add_row: false,
                show_parent_col: false
            };
            this.default_configs = {
                css: {
                    expand_class: 'plus',
                    collapse_class: 'minus',
                    add_class: 'plus',
                    edit_class: '',
                    delete_class: '',
                    save_class: '',
                    cancel_class: ''
                },
                actions: {
                    edit: false,
                    add: false,
                    delete: false,
                    resolve_edit: false,
                    resolve_add: false,
                    resolve_delete: false,
                    edit_parent: false
                },
                data_loading_text: 'Loading...',
                row_class_function: ( /**
                 * @return {?}
                 */function () { return true; }),
                row_edit_function: ( /**
                 * @return {?}
                 */function () { return true; }),
                row_delete_function: ( /**
                 * @return {?}
                 */function () { return true; })
            };
            this.default_column_config = {
                sorted: 0,
                sort_type: null,
                editable: false,
                hidden: false,
                sortable: true
            };
            this.cellclick = new i0.EventEmitter();
            this.expand = new i0.EventEmitter();
            this.collapse = new i0.EventEmitter();
            this.rowselect = new i0.EventEmitter();
            this.rowadd = new i0.EventEmitter();
            this.rowsave = new i0.EventEmitter();
            this.rowdelete = new i0.EventEmitter();
        }
        /**
         * @return {?}
         */
        AngularTreeGridComponent.prototype.ngOnChanges = /**
         * @return {?}
         */
            function () {
                if (!this.validateConfigs()) {
                    return;
                }
                this.setDefaultConfigs();
                this.setColumnNames();
                this.angularTreeGridService.processData(this.data, this.processed_data, this.expand_tracker, this.configs, this.edit_tracker, this.internal_configs);
            };
        /**
         * @return {?}
         */
        AngularTreeGridComponent.prototype.validateConfigs = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var element = this.data[0];
                /** @type {?} */
                var isValidated = true;
                if (!this.configs.id_field) {
                    isValidated = false;
                    window.console.error('id field is mandatory!');
                }
                if (!this.configs.parent_id_field) {
                    isValidated = false;
                    window.console.error('parent_id field is mandatory!');
                }
                if (!element.hasOwnProperty(this.configs.id_field)) {
                    isValidated = false;
                    console.error('id_field doesn\'t exist!');
                }
                if (!element.hasOwnProperty(this.configs.parent_id_field)) {
                    isValidated = false;
                    console.error('parent_id_field doesn\'t exist!');
                }
                if (!element.hasOwnProperty(this.configs.parent_display_field)) {
                    isValidated = false;
                    console.error('parent_display_field doesn\'t exist!');
                }
                return isValidated;
            };
        /**
         * @return {?}
         */
        AngularTreeGridComponent.prototype.setDefaultConfigs = /**
         * @return {?}
         */
            function () {
                this.processed_data = [];
                this.configs = Object.assign({}, this.default_configs, this.configs);
                // Deep clone.
                this.configs.actions = Object.assign({}, this.default_configs.actions, this.configs.actions);
                this.configs.css = Object.assign({}, this.default_configs.css, this.configs.css);
            };
        /**
         * @return {?}
         */
        AngularTreeGridComponent.prototype.setColumnNames = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.columns = this.configs.columns ? this.configs.columns : [];
                // If columns doesn't exist in user's object.
                if (!this.configs.columns) {
                    /** @type {?} */
                    var column_keys = Object.keys(this.data[0]);
                    // Insert Header and default configuration.
                    column_keys.forEach(( /**
                     * @param {?} key
                     * @return {?}
                     */function (key) {
                        _this.columns.push(Object.assign({ 'header': key, 'name': key }, _this.default_column_config));
                    }));
                }
                else {
                    // Insert Header and default configuration.
                    for (var i = 0; i < this.columns.length; i++) {
                        this.columns[i] = Object.assign({}, this.default_column_config, this.columns[i]);
                    }
                }
            };
        AngularTreeGridComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'db-angular-tree-grid',
                        template: "<table class=\"db-tree-view\">\r\n    <thead \r\n        db-tree-head\r\n        [processed_data]=\"processed_data\"\r\n        [expand_tracker]=\"expand_tracker\"\r\n        [internal_configs]=\"internal_configs\"\r\n        [edit_tracker]=\"edit_tracker\"\r\n        [data]=\"data\"\r\n        [columns]=\"columns\"\r\n        [configs]=\"configs\">\r\n    </thead>\r\n\r\n    <tbody \r\n        db-tree-body\r\n        [processed_data]=\"processed_data\"\r\n        [expand_tracker]=\"expand_tracker\"\r\n        [edit_tracker]=\"edit_tracker\"\r\n        [internal_configs]=\"internal_configs\"\r\n        [data]=\"data\"\r\n        [columns]=\"columns\"\r\n        [configs]=\"configs\"\r\n        [cellclick]=\"cellclick\"\r\n        [expand]=\"expand\"\r\n        [collapse]=\"collapse\"\r\n        [rowdelete]=\"rowdelete\"\r\n        [rowsave]=\"rowsave\"\r\n        [rowadd]=\"rowadd\"\r\n    >        \r\n    </tbody>\r\n</table>",
                        styles: [".db-tree-view{line-height:1.5em;border-collapse:collapse;border-spacing:0;display:table;width:100%;max-width:100%;overflow:auto;word-break:normal;word-break:keep-all;border:1px solid gray;color:#4b4b4b}"]
                    }] }
        ];
        /** @nocollapse */
        AngularTreeGridComponent.ctorParameters = function () {
            return [
                { type: AngularTreeGridService }
            ];
        };
        AngularTreeGridComponent.propDecorators = {
            data: [{ type: i0.Input }],
            configs: [{ type: i0.Input }],
            cellclick: [{ type: i0.Output }],
            expand: [{ type: i0.Output }],
            collapse: [{ type: i0.Output }],
            rowselect: [{ type: i0.Output }],
            rowadd: [{ type: i0.Output }],
            rowsave: [{ type: i0.Output }],
            rowdelete: [{ type: i0.Output }]
        };
        return AngularTreeGridComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TreeBodyComponent = /** @class */ (function () {
        function TreeBodyComponent(angularTreeGridService) {
            this.angularTreeGridService = angularTreeGridService;
        }
        /**
         * @return {?}
         */
        TreeBodyComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.parents = this.data.map(( /**
                 * @param {?} element
                 * @return {?}
                 */function (element) {
                    return {
                        'id': element[_this.configs.id_field],
                        'value': element[_this.configs.parent_display_field]
                    };
                }));
            };
        /**
         * @param {?} element
         * @return {?}
         */
        TreeBodyComponent.prototype.refreshData = /**
         * @param {?} element
         * @return {?}
         */
            function (element) {
                // If edit parent is not tru then don't refresh.
                if (!this.configs.actions.edit_parent) {
                    return;
                }
                element[this.configs.parent_id_field] = parseInt(element[this.configs.parent_id_field], 10);
                this.processed_data = [];
                this.expand_tracker = {};
                this.edit_tracker = {};
                this.angularTreeGridService.processData(this.data, this.processed_data, this.expand_tracker, this.configs, this.edit_tracker, this.internal_configs);
            };
        /**
         * @param {?} event
         * @return {?}
         */
        TreeBodyComponent.prototype.onRowExpand = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                /** @type {?} */
                var row_data = event.data;
                this.expand_tracker[row_data.pathx] = true;
                this.expand.emit(event);
            };
        /**
         * @param {?} event
         * @return {?}
         */
        TreeBodyComponent.prototype.onRowCollapse = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                var _this = this;
                /** @type {?} */
                var row_data = event.data;
                this.expand_tracker[row_data.pathx] = false;
                // Collapse all of its children.
                /** @type {?} */
                var keys = Object.keys(this.expand_tracker);
                keys.forEach(( /**
                 * @param {?} key
                 * @return {?}
                 */function (key) {
                    if (key.includes(row_data.pathx)) {
                        _this.expand_tracker[key] = 0;
                    }
                }));
                this.collapse.emit(event);
            };
        /**
         * @param {?} $event
         * @return {?}
         */
        TreeBodyComponent.prototype.saveRecord = /**
         * @param {?} $event
         * @return {?}
         */
            function ($event) {
                var _this = this;
                /** @type {?} */
                var element = $event.data;
                if (this.configs.actions.resolve_edit) {
                    /** @type {?} */
                    var promise = new Promise(( /**
                     * @param {?} resolve
                     * @param {?} reject
                     * @return {?}
                     */function (resolve, reject) {
                        _this.rowsave.emit({
                            data: element,
                            resolve: resolve
                        });
                    }));
                    promise.then(( /**
                     * @return {?}
                     */function () {
                        _this.edit_tracker[element['idx']] = false;
                        _this.refreshData(element);
                    })).catch(( /**
                     * @param {?} err
                     * @return {?}
                     */function (err) { }));
                }
                else {
                    this.edit_tracker[element['idx']] = false;
                    this.refreshData(element);
                    this.rowsave.emit(element);
                }
            };
        /**
         * @param {?} element
         * @return {?}
         */
        TreeBodyComponent.prototype.addRow = /**
         * @param {?} element
         * @return {?}
         */
            function (element) {
                this.refreshData(element);
                this.rowadd.emit(element);
            };
        /**
         * @param {?} index
         * @return {?}
         */
        TreeBodyComponent.prototype.cancelEdit = /**
         * @param {?} index
         * @return {?}
         */
            function (index) {
                this.edit_tracker[index] = false;
                this.internal_configs.show_parent_col = false;
            };
        TreeBodyComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: '[db-tree-body]',
                        template: "<tr *ngIf=\"data.length==0\">\r\n  <td [innerHTML]=\"configs.data_loading_text\" [attr.colspan]=\"columns.length + 1\" style=\"text-align: center\"></td>\r\n</tr>\r\n<tr db-add-row \r\n  [columns]=\"columns\" \r\n  [configs]=\"configs\" \r\n  [internal_configs]=\"internal_configs\" \r\n  [processed_data]=\"processed_data\" \r\n  [data]=\"data\"\r\n  (rowadd)=\"addRow($event)\"\r\n  *ngIf=\"internal_configs.show_add_row\"\r\n  class=\"{{configs.row_class_function(data)}}\">\r\n</tr>\r\n<tr *ngFor=\"let row_data of processed_data\" class=\"{{configs.row_class_function(data)}}\">\r\n  <td db-tree-cell-actions \r\n    *ngIf=\"(configs.actions.edit || configs.actions.delete || configs.actions.add) && expand_tracker[row_data.parent_pathx]\" \r\n    [row_data]=\"row_data\"\r\n    [configs]=\"configs\"\r\n    [processed_data]=\"processed_data\"\r\n    [edit_tracker]=\"edit_tracker\"\r\n    [internal_configs]=\"internal_configs\"\r\n    [rowdelete]=\"rowdelete\"\r\n    (canceledit)=\"cancelEdit($event)\" \r\n    (editcomplete)=\"saveRecord($event)\">\r\n  </td>\r\n  <ng-container *ngIf=\"expand_tracker[row_data.parent_pathx]\">\r\n    <td *ngFor=\"let column of columns; index as i\" [ngClass]=\"{'column-hide': column.hidden}\">\r\n      <db-tree-cell\r\n        [configs]=\"configs\"\r\n        [column]=\"column\"\r\n        [index]=\"i\"\r\n        [row_data]=\"row_data\"\r\n        [expand_tracker]=\"expand_tracker\"\r\n        [edit_on]=\"edit_tracker[row_data[configs.id_field]]\"\r\n        [cellclick]=\"cellclick\"\r\n        (rowexpand)=\"onRowExpand($event)\"\r\n        (rowcollapse)=\"onRowCollapse($event)\"\r\n        (editcomplete)=\"saveRecord($event)\"\r\n      >\r\n      </db-tree-cell>\r\n    </td>\r\n    <td *ngIf=\"internal_configs.show_parent_col\">\r\n      <select *ngIf=\"edit_tracker[row_data[configs.id_field]] &&\r\n         !internal_configs.top_parents.includes(row_data[configs.parent_id_field])\" \r\n        [(ngModel)]=\"row_data[configs.parent_id_field]\">\r\n        <option *ngFor=\"let parent of parents\" [value]=\"parent.id\">{{parent.value}}</option>\r\n      </select>\r\n    </td>\r\n  </ng-container>\r\n</tr>",
                        styles: [".db-tree-view{line-height:1.5em;border-collapse:collapse;border-spacing:0;display:table;width:100%;max-width:100%;overflow:auto;word-break:normal;word-break:keep-all;border:1px solid gray;color:#4b4b4b}tr.selected{background-color:#e2e7eb}tr span.parent_container{padding-left:45px}tr.child{background:#fff}tr.child td:nth-child(2){padding:.875rem 1.25rem .875rem 2.5rem!important}tr.parent{background:#fafbff}tr td{border:1px solid #cdd5dc;vertical-align:middle;position:relative;padding:.5rem}tr td.column-hide{display:none}tr td.clear-left-border{border-left:0!important}tr td.clear-right-border{border-right:0!important}"]
                    }] }
        ];
        /** @nocollapse */
        TreeBodyComponent.ctorParameters = function () {
            return [
                { type: AngularTreeGridService }
            ];
        };
        TreeBodyComponent.propDecorators = {
            data: [{ type: i0.Input }],
            configs: [{ type: i0.Input }],
            processed_data: [{ type: i0.Input }],
            expand_tracker: [{ type: i0.Input }],
            edit_tracker: [{ type: i0.Input }],
            internal_configs: [{ type: i0.Input }],
            columns: [{ type: i0.Input }],
            cellclick: [{ type: i0.Input }],
            expand: [{ type: i0.Input }],
            collapse: [{ type: i0.Input }],
            rowdelete: [{ type: i0.Input }],
            rowsave: [{ type: i0.Input }],
            rowadd: [{ type: i0.Input }]
        };
        return TreeBodyComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TreeCellComponent = /** @class */ (function () {
        function TreeCellComponent() {
            this.rowexpand = new i0.EventEmitter();
            this.rowcollapse = new i0.EventEmitter();
            this.canceledit = new i0.EventEmitter();
            this.editcomplete = new i0.EventEmitter();
        }
        /**
         * @return {?}
         */
        TreeCellComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                this.is_expand_column = this.index === 0;
                this.show_expand_icon = !this.row_data.leaf;
                this.cell_value = this.row_data[this.column.name];
            };
        /**
         * @param {?} event
         * @return {?}
         */
        TreeCellComponent.prototype.expandRow = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                if (this.index === 0 && !this.row_data.leaf) {
                    this.rowexpand.emit({ event: event, data: this.row_data });
                }
            };
        /**
         * @param {?} event
         * @return {?}
         */
        TreeCellComponent.prototype.collapseRow = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                if (this.index === 0 && !this.row_data.leaf) {
                    this.rowcollapse.emit({ event: event, data: this.row_data });
                }
            };
        /**
         * @param {?} event
         * @return {?}
         */
        TreeCellComponent.prototype.onCellClick = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                this.cellclick.emit({ event: event, data: this.row_data });
            };
        /**
         * @param {?} $event
         * @return {?}
         */
        TreeCellComponent.prototype.onEditComplete = /**
         * @param {?} $event
         * @return {?}
         */
            function ($event) {
                this.editcomplete.emit({ event: $event, data: this.row_data });
            };
        TreeCellComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'db-tree-cell',
                        template: "<div (click)=\"onCellClick($event)\">\r\n  <ng-container *ngIf=\"is_expand_column\">\r\n    <div [ngStyle]=\"{'padding-left': row_data.leaf ? row_data.levelx * 20 + 'px' : row_data.levelx * 10 + 'px'}\">\r\n      <ng-container *ngIf=\"!expand_tracker[row_data.pathx]\">\r\n        <span (click)=\"expandRow($event)\">\r\n          <i \r\n            [ngClass]=\"configs.css.expand_class\" \r\n            class=\"expand-icon\" \r\n            aria-hidden=\"true\"\r\n            *ngIf=\"show_expand_icon\"\r\n          ></i>\r\n        </span>\r\n      </ng-container>\r\n      <ng-container *ngIf=\"expand_tracker[row_data.pathx]\">\r\n        <span (click)=\"collapseRow($event)\">\r\n          <i \r\n            [ngClass]=\"configs.css.collapse_class\" \r\n            class=\"expand-icon\" \r\n            aria-hidden=\"true\"\r\n            \r\n            *ngIf=\"show_expand_icon\"\r\n          ></i>\r\n        </span>          \r\n      </ng-container>      \r\n      <ng-container *ngIf=\"!edit_on || !column.editable\" [ngSwitch]=\"column.type\">\r\n        <db-custom-cell-component \r\n          *ngSwitchCase=\"'custom'\"\r\n          [column]=\"column\" \r\n          [row_data]=\"row_data\">\r\n        </db-custom-cell-component>\r\n        <db-tree-cell-view\r\n          *ngSwitchDefault \r\n          [column] = \"column\"\r\n          [row_data] = \"row_data\">\r\n        </db-tree-cell-view>\r\n      </ng-container>\r\n      <ng-container *ngIf=\"edit_on && column.editable\">\r\n          <db-custom-cell-editor-component \r\n            *ngIf=\"column.editor\" \r\n            [cell_value]=\"cell_value\" \r\n            [column]=\"column\" \r\n            [row_data]=\"row_data\"\r\n            (canceledit)=\"canceledit.emit(row_data['idx'])\"\r\n            (editcomplete)=\"onEditComplete($event)\">\r\n        </db-custom-cell-editor-component>\r\n        <db-tree-cell-editor \r\n            *ngIf=\"!column.editor\"\r\n            [cell_value]=\"cell_value\" \r\n            [row_data]=\"row_data\" \r\n            [column]=\"column\"\r\n            (canceledit)=\"canceledit.emit(row_data['idx'])\"\r\n            (editcomplete)=\"onEditComplete($event)\"\r\n            >\r\n        </db-tree-cell-editor>\r\n      </ng-container>\r\n    </div>\r\n  </ng-container>\r\n  <ng-container *ngIf=\"!is_expand_column\">\r\n    <ng-container *ngIf=\"!edit_on || !column.editable\" [ngSwitch]=\"column.type\">\r\n      <db-custom-cell-component \r\n        *ngSwitchCase=\"'custom'\"\r\n        [column]=\"column\" \r\n        [row_data]=\"row_data\">\r\n      </db-custom-cell-component>\r\n      <db-tree-cell-view\r\n        *ngSwitchDefault \r\n        [column] = \"column\"\r\n        [row_data] = \"row_data\">\r\n      </db-tree-cell-view>\r\n    </ng-container> \r\n\r\n    <ng-container *ngIf=\"edit_on && column.editable\">\r\n        <db-custom-cell-editor-component \r\n          *ngIf=\"column.editor\" \r\n          [cell_value]=\"cell_value\" \r\n          [column]=\"column\" \r\n          [row_data]=\"row_data\"\r\n          (canceledit)=\"canceledit.emit(row_data['idx'])\"\r\n          (editcomplete)=\"onEditComplete($event)\">\r\n      </db-custom-cell-editor-component>\r\n      <db-tree-cell-editor \r\n          *ngIf=\"!column.editor\"\r\n          [cell_value]=\"cell_value\" \r\n          [row_data]=\"row_data\" \r\n          [column]=\"column\"\r\n          (canceledit)=\"canceledit.emit(row_data['idx'])\"\r\n          (editcomplete)=\"onEditComplete($event)\"\r\n          >\r\n      </db-tree-cell-editor>\r\n    </ng-container> \r\n  </ng-container>\r\n</div>\r\n",
                        styles: [".db-tree-view{line-height:1.5em;border-collapse:collapse;border-spacing:0;display:table;width:100%;max-width:100%;overflow:auto;word-break:normal;word-break:keep-all;border:1px solid gray;color:#4b4b4b}i.expand-icon{margin-right:33px}i.plus{border:1px solid transparent}i.plus:before{content:'';width:18px;height:1px;border-top:2px solid #222;display:block;position:absolute;margin-top:-15px;margin-left:6px}i.plus:after{content:'';width:1px;height:18px;border-right:2px solid #222;display:block;position:absolute;margin-top:-23px;margin-left:14px}i.minus{border:1px solid transparent}i.minus:before{content:'';width:18px;height:1px;border-top:2px solid #222;display:block;position:absolute;margin-top:-15px;margin-left:6px}"]
                    }] }
        ];
        /** @nocollapse */
        TreeCellComponent.ctorParameters = function () { return []; };
        TreeCellComponent.propDecorators = {
            configs: [{ type: i0.Input }],
            index: [{ type: i0.Input }],
            row_data: [{ type: i0.Input }],
            column: [{ type: i0.Input }],
            expand_tracker: [{ type: i0.Input }],
            cellclick: [{ type: i0.Input }],
            edit_on: [{ type: i0.Input }],
            rowexpand: [{ type: i0.Output }],
            rowcollapse: [{ type: i0.Output }],
            canceledit: [{ type: i0.Output }],
            editcomplete: [{ type: i0.Output }]
        };
        return TreeCellComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TreeCellViewComponent = /** @class */ (function () {
        function TreeCellViewComponent() {
        }
        /**
         * @return {?}
         */
        TreeCellViewComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
            };
        TreeCellViewComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'db-tree-cell-view',
                        template: "<span>{{column.renderer ? column.renderer(row_data[column.name], row_data) : row_data[column.name]}}</span>\n",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        TreeCellViewComponent.ctorParameters = function () { return []; };
        TreeCellViewComponent.propDecorators = {
            column: [{ type: i0.Input }],
            row_data: [{ type: i0.Input }]
        };
        return TreeCellViewComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CustomCellViewComponent = /** @class */ (function () {
        function CustomCellViewComponent(resolver) {
            this.resolver = resolver;
        }
        /**
         * @return {?}
         */
        CustomCellViewComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                if (this.column.component && !this.customComponent) {
                    this.createCustomComponent();
                    this.callOnComponentInit();
                }
            };
        /**
         * @return {?}
         */
        CustomCellViewComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                if (this.customComponent) {
                    this.customComponent.destroy();
                }
            };
        /**
         * @protected
         * @return {?}
         */
        CustomCellViewComponent.prototype.createCustomComponent = /**
         * @protected
         * @return {?}
         */
            function () {
                /** @type {?} */
                var componentFactory = this.resolver.resolveComponentFactory(this.column.component);
                this.customComponent = this.dynamicTarget.createComponent(componentFactory);
            };
        /**
         * @protected
         * @return {?}
         */
        CustomCellViewComponent.prototype.callOnComponentInit = /**
         * @protected
         * @return {?}
         */
            function () {
                this.column.onComponentInit && this.column.onComponentInit(this.customComponent.instance);
                this.customComponent.instance.cell_value = this.row_data[this.column.name];
                this.customComponent.instance.row_data = this.row_data;
            };
        CustomCellViewComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'db-custom-cell-component',
                        template: "\n      <ng-template #dynamicTarget></ng-template>\n    "
                    }] }
        ];
        /** @nocollapse */
        CustomCellViewComponent.ctorParameters = function () {
            return [
                { type: i0.ComponentFactoryResolver }
            ];
        };
        CustomCellViewComponent.propDecorators = {
            column: [{ type: i0.Input }],
            row_data: [{ type: i0.Input }],
            dynamicTarget: [{ type: i0.ViewChild, args: ['dynamicTarget', { read: i0.ViewContainerRef },] }]
        };
        return CustomCellViewComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TreeCellActionsComponent = /** @class */ (function () {
        function TreeCellActionsComponent() {
            this.editcomplete = new i0.EventEmitter();
            this.canceledit = new i0.EventEmitter();
        }
        /**
         * @return {?}
         */
        TreeCellActionsComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
            };
        /**
         * @param {?} index
         * @return {?}
         */
        TreeCellActionsComponent.prototype.enableEdit = /**
         * @param {?} index
         * @return {?}
         */
            function (index) {
                this.edit_tracker[index] = true;
                // Only if edit_parent is true.
                if (this.configs.actions.edit_parent) {
                    this.internal_configs.show_parent_col = true;
                }
            };
        /**
         * @param {?} idx
         * @return {?}
         */
        TreeCellActionsComponent.prototype.findRecordIndex = /**
         * @param {?} idx
         * @return {?}
         */
            function (idx) {
                for (var index in this.processed_data) {
                    if (this.processed_data[index].idx === idx) {
                        return index;
                    }
                }
            };
        /**
         * @param {?} rec
         * @return {?}
         */
        TreeCellActionsComponent.prototype.deleteRecord = /**
         * @param {?} rec
         * @return {?}
         */
            function (rec) {
                var _this = this;
                if (this.configs.actions.resolve_delete) {
                    /** @type {?} */
                    var promise = new Promise(( /**
                     * @param {?} resolve
                     * @param {?} reject
                     * @return {?}
                     */function (resolve, reject) {
                        _this.rowdelete.emit({
                            data: rec,
                            resolve: resolve
                        });
                    }));
                    promise.then(( /**
                     * @return {?}
                     */function () {
                        _this.processed_data.splice(_this.findRecordIndex(rec.idx), 1);
                    })).catch(( /**
                     * @param {?} err
                     * @return {?}
                     */function (err) { }));
                }
                else {
                    this.processed_data.splice(this.findRecordIndex(rec.idx), 1);
                    this.rowdelete.emit(rec);
                }
            };
        /**
         * @param {?} $event
         * @return {?}
         */
        TreeCellActionsComponent.prototype.saveRecord = /**
         * @param {?} $event
         * @return {?}
         */
            function ($event) {
                this.editcomplete.emit({ event: $event, data: this.row_data });
            };
        TreeCellActionsComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: '[db-tree-cell-actions]',
                        template: "<ng-container *ngIf=\"configs.actions.edit && configs.row_edit_function(row_data)\">\r\n  <ng-container *ngIf=\"!edit_tracker[row_data[configs.id_field]]\">\r\n    <i (click)=\"enableEdit(row_data[configs.id_field])\" *ngIf=\"configs.css.edit_class\" title=\"Edit row\" class=\"{{this.configs.css.edit_class}}\" aria-hidden=\"true\" ></i>\r\n    <svg (click)=\"enableEdit(row_data[configs.id_field])\" *ngIf=\"!configs.css.edit_class\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>Edit row</title><g data-name=\"Layer 2\"><g data-name=\"edit\"><rect width=\"24\" height=\"24\" opacity=\"0\"/><path d=\"M19.4 7.34L16.66 4.6A2 2 0 0 0 14 4.53l-9 9a2 2 0 0 0-.57 1.21L4 18.91a1 1 0 0 0 .29.8A1 1 0 0 0 5 20h.09l4.17-.38a2 2 0 0 0 1.21-.57l9-9a1.92 1.92 0 0 0-.07-2.71zM9.08 17.62l-3 .28.27-3L12 9.32l2.7 2.7zM16 10.68L13.32 8l1.95-2L18 8.73z\"/></g></g></svg>             \r\n  </ng-container>\r\n  <ng-container *ngIf=\"edit_tracker[row_data[configs.id_field]]\">\r\n    <i (click)=\"saveRecord($event)\" *ngIf=\"configs.css.save_class\" title=\"Save row\" class=\"{{this.configs.css.save_class}}\" aria-hidden=\"true\"></i>\r\n    <svg (click)=\"saveRecord($event)\" title=\"Save row\" *ngIf=\"!configs.css.save_class\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>Save row</title><g data-name=\"Layer 2\"><g data-name=\"save\"><rect width=\"24\" height=\"24\" opacity=\"0\"/><path d=\"M20.12 8.71l-4.83-4.83A3 3 0 0 0 13.17 3H6a3 3 0 0 0-3 3v12a3 3 0 0 0 3 3h12a3 3 0 0 0 3-3v-7.17a3 3 0 0 0-.88-2.12zM10 19v-2h4v2zm9-1a1 1 0 0 1-1 1h-2v-3a1 1 0 0 0-1-1H9a1 1 0 0 0-1 1v3H6a1 1 0 0 1-1-1V6a1 1 0 0 1 1-1h2v5a1 1 0 0 0 1 1h4a1 1 0 0 0 0-2h-3V5h3.17a1.05 1.05 0 0 1 .71.29l4.83 4.83a1 1 0 0 1 .29.71z\"/></g></g></svg>\r\n    <i (click)=\"canceledit.emit(row_data[configs.id_field])\" *ngIf=\"configs.css.cancel_class\" title=\"Cancel row\" class=\"{{this.configs.css.cancel_class}}\" aria-hidden=\"true\"></i>\r\n    <svg (click)=\"canceledit.emit(row_data[configs.id_field])\" *ngIf=\"!configs.css.cancel_class\" title=\"Cancel row\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>Cancel row</title><g data-name=\"Layer 2\"><g data-name=\"close\"><rect width=\"24\" height=\"24\" transform=\"rotate(180 12 12)\" opacity=\"0\"/><path d=\"M13.41 12l4.3-4.29a1 1 0 1 0-1.42-1.42L12 10.59l-4.29-4.3a1 1 0 0 0-1.42 1.42l4.3 4.29-4.3 4.29a1 1 0 0 0 0 1.42 1 1 0 0 0 1.42 0l4.29-4.3 4.29 4.3a1 1 0 0 0 1.42 0 1 1 0 0 0 0-1.42z\"/></g></g></svg>\r\n  </ng-container>\r\n</ng-container>            \r\n<ng-container \r\n  *ngIf=\"\r\n      configs.actions.delete && \r\n      !edit_tracker[row_data[configs.id_field]] && \r\n      configs.row_delete_function(row_data)\">\r\n  <i *ngIf=\"configs.css.delete_class\" title=\"Delete row\" (click)=\"deleteRecord(row_data)\" class=\"{{this.configs.css.delete_class}}\" aria-hidden=\"true\"></i>\r\n  <svg *ngIf=\"!configs.css.delete_class\" title=\"Delete row\" (click)=\"deleteRecord(row_data)\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>Delete row</title><g data-name=\"Layer 2\"><g data-name=\"trash-2\"><rect width=\"24\" height=\"24\" opacity=\"0\"/><path d=\"M21 6h-5V4.33A2.42 2.42 0 0 0 13.5 2h-3A2.42 2.42 0 0 0 8 4.33V6H3a1 1 0 0 0 0 2h1v11a3 3 0 0 0 3 3h10a3 3 0 0 0 3-3V8h1a1 1 0 0 0 0-2zM10 4.33c0-.16.21-.33.5-.33h3c.29 0 .5.17.5.33V6h-4zM18 19a1 1 0 0 1-1 1H7a1 1 0 0 1-1-1V8h12z\"/><path d=\"M9 17a1 1 0 0 0 1-1v-4a1 1 0 0 0-2 0v4a1 1 0 0 0 1 1z\"/><path d=\"M15 17a1 1 0 0 0 1-1v-4a1 1 0 0 0-2 0v4a1 1 0 0 0 1 1z\"/></g></g></svg>            \r\n</ng-container>",
                        styles: ["svg{width:25px;padding-right:5px}"]
                    }] }
        ];
        /** @nocollapse */
        TreeCellActionsComponent.ctorParameters = function () { return []; };
        TreeCellActionsComponent.propDecorators = {
            processed_data: [{ type: i0.Input }],
            edit_tracker: [{ type: i0.Input }],
            internal_configs: [{ type: i0.Input }],
            configs: [{ type: i0.Input }],
            rowdelete: [{ type: i0.Input }],
            row_data: [{ type: i0.Input }],
            editcomplete: [{ type: i0.Output }],
            canceledit: [{ type: i0.Output }]
        };
        return TreeCellActionsComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DefaultEditor = /** @class */ (function () {
        function DefaultEditor() {
            this.canceledit = new i0.EventEmitter();
            this.editcomplete = new i0.EventEmitter();
            this.cellclick = new i0.EventEmitter();
        }
        DefaultEditor.propDecorators = {
            canceledit: [{ type: i0.Output }],
            editcomplete: [{ type: i0.Output }],
            cellclick: [{ type: i0.Output }]
        };
        return DefaultEditor;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CustomCellEditorComponent = /** @class */ (function (_super) {
        __extends(CustomCellEditorComponent, _super);
        function CustomCellEditorComponent(resolver) {
            var _this = _super.call(this) || this;
            _this.resolver = resolver;
            return _this;
        }
        /**
         * @return {?}
         */
        CustomCellEditorComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                if (this.column.editor && !this.customComponent) {
                    this.createCustomComponent();
                    this.callOnComponentInit();
                }
            };
        /**
         * @return {?}
         */
        CustomCellEditorComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                if (this.customComponent) {
                    this.customComponent.destroy();
                }
            };
        /**
         * @protected
         * @return {?}
         */
        CustomCellEditorComponent.prototype.createCustomComponent = /**
         * @protected
         * @return {?}
         */
            function () {
                /** @type {?} */
                var componentFactory = this.resolver.resolveComponentFactory(this.column.editor);
                this.customComponent = this.dynamicTarget.createComponent(componentFactory);
            };
        /**
         * @protected
         * @return {?}
         */
        CustomCellEditorComponent.prototype.callOnComponentInit = /**
         * @protected
         * @return {?}
         */
            function () {
                var _this = this;
                this.column.onComponentInit && this.column.onComponentInit(this.customComponent.instance);
                this.customComponent.instance.cell_value = this.cell_value;
                this.customComponent.instance.row_data = this.row_data;
                this.customComponent.instance.column = this.column;
                this.customComponent.instance.editcomplete.subscribe(( /**
                 * @param {?} event
                 * @return {?}
                 */function (event) { return _this.editcomplete.emit(event); }));
                this.customComponent.instance.canceledit.subscribe(( /**
                 * @param {?} event
                 * @return {?}
                 */function (event) { return _this.canceledit.emit(event); }));
                this.customComponent.instance.cellclick.subscribe(( /**
                 * @param {?} event
                 * @return {?}
                 */function (event) { return _this.cellclick.emit(event); }));
            };
        CustomCellEditorComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'db-custom-cell-editor-component',
                        template: "\n      <ng-template #dynamicTarget></ng-template>\n    "
                    }] }
        ];
        /** @nocollapse */
        CustomCellEditorComponent.ctorParameters = function () {
            return [
                { type: i0.ComponentFactoryResolver }
            ];
        };
        CustomCellEditorComponent.propDecorators = {
            column: [{ type: i0.Input }],
            cell_value: [{ type: i0.Input }],
            row_data: [{ type: i0.Input }],
            dynamicTarget: [{ type: i0.ViewChild, args: ['dynamicTarget', { read: i0.ViewContainerRef },] }]
        };
        return CustomCellEditorComponent;
    }(DefaultEditor));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TreeCellEditorComponent = /** @class */ (function (_super) {
        __extends(TreeCellEditorComponent, _super);
        function TreeCellEditorComponent() {
            return _super.call(this) || this;
        }
        /**
         * @return {?}
         */
        TreeCellEditorComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
            };
        TreeCellEditorComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'db-tree-cell-editor',
                        template: "<input type=\"text\" \r\n    [(ngModel)]=\"row_data[column.name]\" \r\n    class=\"cell-default\" \r\n    (click)=\"cellclick.emit($event)\"\r\n    (keydown.enter)=\"editcomplete.emit($event)\"\r\n    (keydown.esc)=\"canceledit.emit()\"\r\n    >",
                        styles: ["input.cell-default{padding:5px}"]
                    }] }
        ];
        /** @nocollapse */
        TreeCellEditorComponent.ctorParameters = function () { return []; };
        TreeCellEditorComponent.propDecorators = {
            cell_value: [{ type: i0.Input }],
            row_data: [{ type: i0.Input }],
            column: [{ type: i0.Input }]
        };
        return TreeCellEditorComponent;
    }(DefaultEditor));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TreeCellModule = /** @class */ (function () {
        function TreeCellModule() {
        }
        TreeCellModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [
                            TreeCellComponent,
                            TreeCellViewComponent,
                            CustomCellViewComponent,
                            TreeCellActionsComponent,
                            CustomCellEditorComponent,
                            TreeCellEditorComponent
                        ],
                        imports: [
                            common.CommonModule,
                            forms.FormsModule
                        ],
                        exports: [
                            TreeCellComponent,
                            CustomCellViewComponent,
                            CustomCellEditorComponent,
                            TreeCellEditorComponent,
                            TreeCellActionsComponent
                        ]
                    },] }
        ];
        return TreeCellModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AddRowComponent = /** @class */ (function () {
        function AddRowComponent() {
            this.row_data = {};
            this.parents = [];
            this.rowadd = new i0.EventEmitter();
            this.canceledit = new i0.EventEmitter();
        }
        /**
         * @return {?}
         */
        AddRowComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.columns.forEach(( /**
                 * @param {?} column
                 * @return {?}
                 */function (column) {
                    _this.row_data[column.name] = '';
                }));
                this.parents = this.data.map(( /**
                 * @param {?} element
                 * @return {?}
                 */function (element) {
                    return {
                        'id': element[_this.configs.id_field],
                        'value': element[_this.configs.parent_display_field]
                    };
                }));
            };
        /**
         * @param {?} e
         * @return {?}
         */
        AddRowComponent.prototype.saveAddRecord = /**
         * @param {?} e
         * @return {?}
         */
            function (e) {
                /** @type {?} */
                var index = this.processed_data.length;
                this.data.push(this.row_data);
                this.internal_configs.show_add_row = false;
                this.rowadd.emit(this.row_data);
            };
        /**
         * @return {?}
         */
        AddRowComponent.prototype.cancelAddEdit = /**
         * @return {?}
         */
            function () {
                this.internal_configs.show_add_row = false;
            };
        AddRowComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: '[db-add-row]',
                        template: "<td>\r\n  <svg (click)=\"saveAddRecord($event)\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>Save row</title><g data-name=\"Layer 2\"><g data-name=\"save\"><rect width=\"24\" height=\"24\" opacity=\"0\"/><path d=\"M20.12 8.71l-4.83-4.83A3 3 0 0 0 13.17 3H6a3 3 0 0 0-3 3v12a3 3 0 0 0 3 3h12a3 3 0 0 0 3-3v-7.17a3 3 0 0 0-.88-2.12zM10 19v-2h4v2zm9-1a1 1 0 0 1-1 1h-2v-3a1 1 0 0 0-1-1H9a1 1 0 0 0-1 1v3H6a1 1 0 0 1-1-1V6a1 1 0 0 1 1-1h2v5a1 1 0 0 0 1 1h4a1 1 0 0 0 0-2h-3V5h3.17a1.05 1.05 0 0 1 .71.29l4.83 4.83a1 1 0 0 1 .29.71z\"/></g></g></svg>\r\n  <svg (click)=\"cancelAddEdit()\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>Cancel row</title><g data-name=\"Layer 2\"><g data-name=\"close\"><rect width=\"24\" height=\"24\" transform=\"rotate(180 12 12)\" opacity=\"0\"/><path d=\"M13.41 12l4.3-4.29a1 1 0 1 0-1.42-1.42L12 10.59l-4.29-4.3a1 1 0 0 0-1.42 1.42l4.3 4.29-4.3 4.29a1 1 0 0 0 0 1.42 1 1 0 0 0 1.42 0l4.29-4.3 4.29 4.3a1 1 0 0 0 1.42 0 1 1 0 0 0 0-1.42z\"/></g></g></svg>\r\n</td>\r\n<td *ngFor=\"let column of columns\" [ngClass]=\"{'column-hide': column.hidden}\" >\r\n  <div *ngIf=\"column.editable\">\r\n    <db-custom-cell-editor-component \r\n        *ngIf=\"column.editor\"\r\n        [cell_value]=\"\" \r\n        [column]=\"column\" \r\n        [row_data]=\"row_data\"\r\n        (canceledit)=\"cancelAddEdit()\"\r\n        (editcomplete)=\"saveAddRecord($event)\">\r\n    </db-custom-cell-editor-component>\r\n    <db-tree-cell-editor \r\n        *ngIf=\"!column.editor\"\r\n        [cell_value]=\"\" \r\n        [row_data]=\"row_data\" \r\n        [column]=\"column\"\r\n        (canceledit)=\"cancelAddEdit()\"\r\n        (editcomplete)=\"saveAddRecord($event)\"\r\n        >\r\n    </db-tree-cell-editor>\r\n  </div>\r\n</td>\r\n<td>\r\n  <select [(ngModel)]=\"row_data[configs.parent_id_field]\">\r\n    <option *ngFor=\"let parent of parents\" [value]=\"parent.id\">{{parent.value}}</option>\r\n  </select>\r\n</td>",
                        encapsulation: i0.ViewEncapsulation.None,
                        styles: [".db-tree-view{line-height:1.5em;border-collapse:collapse;border-spacing:0;display:table;width:100%;max-width:100%;overflow:auto;word-break:normal;word-break:keep-all;border:1px solid gray;color:#4b4b4b}tr.selected{background-color:#e2e7eb}tr span.parent_container{padding-left:45px}tr.child{background:#fff}tr.child td:nth-child(2){padding:.875rem 1.25rem .875rem 2.5rem!important}tr.parent{background:#fafbff}tr td{border:1px solid #cdd5dc;vertical-align:middle;position:relative;padding:.5rem}tr td.column-hide{display:none}tr td.clear-left-border{border-left:0!important}tr td.clear-right-border{border-right:0!important}svg{width:25px;padding-right:5px}"]
                    }] }
        ];
        /** @nocollapse */
        AddRowComponent.ctorParameters = function () { return []; };
        AddRowComponent.propDecorators = {
            data: [{ type: i0.Input }],
            processed_data: [{ type: i0.Input }],
            columns: [{ type: i0.Input }],
            configs: [{ type: i0.Input }],
            internal_configs: [{ type: i0.Input }],
            rowadd: [{ type: i0.Output }],
            canceledit: [{ type: i0.Output }]
        };
        return AddRowComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TreeBodyModule = /** @class */ (function () {
        function TreeBodyModule() {
        }
        TreeBodyModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [TreeBodyComponent, AddRowComponent],
                        imports: [
                            common.CommonModule,
                            TreeCellModule,
                            forms.FormsModule
                        ],
                        exports: [TreeBodyComponent]
                    },] }
        ];
        return TreeBodyModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TreeHeadComponent = /** @class */ (function () {
        function TreeHeadComponent() {
        }
        /**
         * @return {?}
         */
        TreeHeadComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
            };
        /**
         * @return {?}
         */
        TreeHeadComponent.prototype.addRow = /**
         * @return {?}
         */
            function () {
                this.internal_configs.show_add_row = true;
            };
        TreeHeadComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: '[db-tree-head]',
                        template: "<tr>\r\n  <th *ngIf=\"configs.actions.add || configs.actions.edit || configs.actions.delete\" class=\"header-editable\" \r\n    (click)=\"addRow()\">\r\n    <i *ngIf=\"!internal_configs.show_add_row && configs.actions.add\" [ngClass]=\"configs.css.add_class\" aria-hidden=\"true\" title=\"Add a row\"></i>\r\n    <span *ngIf=\"internal_configs.show_add_row || !configs.actions.add\">Actions</span>\r\n  </th>\r\n  <th *ngFor=\"let column of columns\" [ngClass]=\"{'column-hide': column.hidden}\">\r\n    <div>{{column.header}}</div>    \r\n  </th>\r\n  <th *ngIf=\"internal_configs.show_parent_col || internal_configs.show_add_row\">\r\n    Parent\r\n  </th>\r\n</tr>",
                        styles: [".db-tree-view{line-height:1.5em;border-collapse:collapse;border-spacing:0;display:table;width:100%;max-width:100%;overflow:auto;word-break:normal;word-break:keep-all;border:1px solid gray;color:#4b4b4b}tr{background:#fff}tr th{padding:.5rem;font-family:Exo;font-size:1rem;font-weight:600;line-height:1.25;color:#181818;border:1px solid #cdd5dc;vertical-align:middle;position:relative}tr th.column-hide{display:none}tr th.header-editable{width:70px}tr th i.plus{border:1px solid transparent}tr th i.plus:before{content:'';width:18px;height:1px;border-top:2px solid #222;display:block;position:absolute;margin-top:-15px;margin-left:6px}tr th i.plus:after{content:'';width:1px;height:18px;border-right:2px solid #222;display:block;position:absolute;margin-top:-23px;margin-left:14px}th.clear-left-border{border-left:0!important}th.clear-right-border{border-right:0!important}.column-hide{display:none}svg{width:25px;padding-right:5px}"]
                    }] }
        ];
        /** @nocollapse */
        TreeHeadComponent.ctorParameters = function () { return []; };
        TreeHeadComponent.propDecorators = {
            data: [{ type: i0.Input }],
            configs: [{ type: i0.Input }],
            processed_data: [{ type: i0.Input }],
            expand_tracker: [{ type: i0.Input }],
            edit_tracker: [{ type: i0.Input }],
            internal_configs: [{ type: i0.Input }],
            columns: [{ type: i0.Input }]
        };
        return TreeHeadComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TreeHeadModule = /** @class */ (function () {
        function TreeHeadModule() {
        }
        TreeHeadModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [TreeHeadComponent],
                        imports: [
                            common.CommonModule
                        ],
                        exports: [TreeHeadComponent]
                    },] }
        ];
        return TreeHeadModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AngularTreeGridModule = /** @class */ (function () {
        function AngularTreeGridModule() {
        }
        AngularTreeGridModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [AngularTreeGridComponent],
                        imports: [
                            common.CommonModule,
                            TreeBodyModule,
                            TreeHeadModule
                        ],
                        exports: [AngularTreeGridComponent]
                    },] }
        ];
        return AngularTreeGridModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.AngularTreeGridService = AngularTreeGridService;
    exports.AngularTreeGridComponent = AngularTreeGridComponent;
    exports.AngularTreeGridModule = AngularTreeGridModule;
    exports.DefaultEditor = DefaultEditor;
    exports.ɵc = AddRowComponent;
    exports.ɵb = TreeBodyComponent;
    exports.ɵa = TreeBodyModule;
    exports.ɵh = TreeCellActionsComponent;
    exports.ɵi = CustomCellEditorComponent;
    exports.ɵj = TreeCellEditorComponent;
    exports.ɵg = CustomCellViewComponent;
    exports.ɵf = TreeCellViewComponent;
    exports.ɵe = TreeCellComponent;
    exports.ɵd = TreeCellModule;
    exports.ɵl = TreeHeadComponent;
    exports.ɵk = TreeHeadModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=angular-tree-grid.umd.js.map